*  Collection of force calculation
*
*=============== INTERNAL FORCES =============================================
*
*   Covalent bonds
*
*=============== GETBND ===========================================
*
      SUBROUTINE GETBND(ITYP)
*
      include "mdee.h"
* 
      character*3 NAMN
      DIMENSION BR(NB),BE(NB)
*                    
      NRBS      = NRB(ITYP)
      IF(NRBS.LE.0) RETURN
      timeb0	= cputime(0.d0)
*
      ISBEG     = ISADDR(ITYP)+1
      ISEND     = ISADDR(ITYP +1)
*     
      NAMN=NAME(ITYP)(1:3)
      NSS       = NSITS (ITYP)
      IF(IPOT(ITYP).eq.1.or.IPOT(ITYP).eq.2)THEN
        CALL STRBND(ITYP)
        timeb	= timeb+cputime(timeb0)
        RETURN
      END IF
*
      NBBEG     = IADB(ITYP)
      NBEND     = NBBEG+NRBS-1
*
      DO M      = NBBEG,NBEND
        BR(M)     = 0.D0
        BE(M)     = 0.D0
      END DO
      NSP       = NSPEC (ITYP)
      FNSPI     = 1.D0/DFLOAT(NSP)
*
      ISHF      = ISADDR(ITYP)
      DO M      = NBBEG,NBEND
        IBB       = IB(M)+ISHF
        JBB       = JB(M)+ISHF
        REQ       = RB(M)
        FCN       = FB(M)
*
        DO K      = 1,NSP
          I         = (K-1)*NSS+IBB
          J         = (K-1)*NSS+JBB
          BX        = SX(J)-SX(I)
          BY        = SY(J)-SY(I)
          BZ        = SZ(J)-SZ(I)
          call PBC(BX,BY,BZ)
          BSQ       = BX*BX+BY*BY+BZ*BZ
          BD        = DSQRT(BSQ)
*     if(ityp.eq.1.and.m.eq.nbbeg) print *,bd
          R1I       = 1.D0/BD
          BBB       =  BD-REQ
          DBND      = BBB*FCN
          EBDD	    = DBND*BBB
          FORB      =  -2.0D0*DBND*R1I
          BR(M)     = BR(M)+BD
          BE(M)     = BE(M)+EBDD
          PINT	    = PINT+EBDD
*          write(*,*)I,J,IS,JS,NM(IS),NM(JS),BD,EBDD*0.001*ENERF
          HX(I)     = HX(I)-BX*FORB
          HY(I)     = HY(I)-BY*FORB
          HZ(I)     = HZ(I)-BZ*FORB
          HX(J)     = HX(J)+BX*FORB
          HY(J)     = HY(J)+BY*FORB
          HZ(J)     = HZ(J)+BZ*FORB
	  VIRFX	    = VIRFX+FORB*BX**2  
	  VIRFY	    = VIRFY+FORB*BY**2  
	  VIRFZ	    = VIRFZ+FORB*BZ**2
        END DO! OF K
*
      END DO! OF M
*
      DO M      = NBBEG,NBEND
        BB(M)     = BB(M)+BR(M)*FNSPI
        EB(M)     = EB(M)+BE(M)*FNSPI
      END DO
*
      timeb	= timeb+cputime(timeb0)
      RETURN
      END
*
*=============== GETANG ===========================================
*
      SUBROUTINE GETANG(ITYP)
*
      include "mdee.h"
*
      DIMENSION AR(NA),AE(NA)
*
      NRAS      = NRA(ITYP)
      IF(NRAS.LE.0) RETURN
*
      timea0	= cputime(0.d0)
      NABEG     = IADA(ITYP)
      NAEND     = NABEG+NRAS-1
*
      DO M      = NABEG,NAEND
        AR(M)     = 0.D0
        AE(M)     = 0.D0
      END DO
*
      ISHF      = ISADDR(ITYP)
      IBEG      = IADDR (ITYP)+1
      IEND      = IADDR (ITYP+1)
      NSP       = NSPEC (ITYP)
      NSS       = NSITS (ITYP)
      FNSPI     = 1.D0/DFLOAT(NSP)
*
      DO M      = NABEG,NAEND
        II        = IA(M)+ISHF
        JJ        = JA(M)+ISHF
        KK        = KA(M)+ISHF
        FCN       = FA(M)
        AEQ       = RA(M)
        DO L      = 1,NSP
          I         = (L-1)*NSS+II
          J         = (L-1)*NSS+JJ
          K         = (L-1)*NSS+KK
*
          AX        = SX(I)-SX(J)
          AY        = SY(I)-SY(J)
          AZ        = SZ(I)-SZ(J)
          call PBC(AX,AY,AZ)
          ASQ       = AX*AX+AY*AY+AZ*AZ
          ASQI      = 1.D0/ASQ
*
          BX        = SX(K)-SX(J)
          BY        = SY(K)-SY(J)
          BZ        = SZ(K)-SZ(J)
          call PBC(BX,BY,BZ)
          BSQ       = BX*BX+BY*BY+BZ*BZ
          BSQI      = 1.D0/BSQ
*
          AB        = DSQRT(ASQ*BSQ)
          ABI       = 1.D0/AB
*
          COSA      = AX*BX+AY*BY+AZ*BZ
          COSA      = COSA*ABI
          COSA      = DMIN1(COSA, 1.D0)
          COSA      = DMAX1(COSA,-1.D0)
          ALF       = DACOS(COSA)
          AVA       = AVA+ALF
          SINA      = DSIN(ALF)
          SINAI     =  1.D0/SINA
          DALF      =  ALF-AEQ
          ABC       = DALF*FCN
          EANG	    = ABC*DALF	
*
          AR(M)     = AR(M)+ALF
          AE(M)     = AE(M)+EANG
          PINT	    = PINT+EANG 
*
*      if(nstep.eq.2)
*     x print  "(2i5,5x,3(1x,a4),f8.2,3x,f18.8)"
*     X ,m,l,nam(i),nam(j),nam(k)
*     x ,alf*180./3.1412,ABC*DALF*enerf*1.d-3
          SAB       =-2.D0*ABC*SINAI
          CAB       = SAB*COSA
          FAB       = SAB*ABI
          FAA       = CAB*ASQI
          FBB       = CAB*BSQI
*
          FAX       = FAB*BX-FAA*AX
          FAY       = FAB*BY-FAA*AY
          FAZ       = FAB*BZ-FAA*AZ
*
          FBX       = FAB*AX-FBB*BX
          FBY       = FAB*AY-FBB*BY
          FBZ       = FAB*AZ-FBB*BZ
*
          HX(I)     = HX(I)-FAX
          HY(I)     = HY(I)-FAY
          HZ(I)     = HZ(I)-FAZ
          HX(J)     = HX(J)+FAX+FBX
          HY(J)     = HY(J)+FAY+FBY
          HZ(J)     = HZ(J)+FAZ+FBZ
          HX(K)     = HX(K)-FBX
          HY(K)     = HY(K)-FBY
          HZ(K)     = HZ(K)-FBZ
	    VIRFX      = VIRFX-AX*FAX-BX*FBX
	    VIRFY      = VIRFY-AY*FAY-BY*FBY
	    VIRFZ      = VIRFZ-AZ*FAZ-BZ*FBZ
        END DO! OF NN
      END DO! OF M
*
      DO M      = NABEG,NAEND
      AA(M)     = AA(M)+AR(M)*FNSPI
      EA(M)     = EA(M)+AE(M)*FNSPI
      END DO
*
      timea	= timea+cputime(timea0)
      RETURN
      END
*
*=============== GETTRS ============================================== 
*
      SUBROUTINE GETTRS(ITYP)
*
      include "mdee.h"
*
      DIMENSION TR(NT),TE(NT)
*
      NRTS      = NRT(ITYP)
      IF(NRTS.LE.0) RETURN
      timet0	= cputime(0.d0)
*
      NTBEG     = IADT(ITYP)
      NTEND     = NTBEG+NRTS-1
*
      DO M      = NTBEG,NTEND
        TR(M)     = 0.D0
        TE(M)     = 0.D0
      END DO
*
      ISHF      = ISADDR(ITYP)
      IBEG      = IADDR (ITYP)+1
      IEND      = IADDR (ITYP+1)
      NSP       = NSPEC (ITYP)
      NSS       = NSITS (ITYP)
      FNSPI     = 1.D0/DFLOAT(NSP)
*
      DO M      = NTBEG,NTEND
        II        = IT(M)+ISHF
        JJ        = JT(M)+ISHF
        KK        = KT(M)+ISHF
        LL        = LT(M)+ISHF
        FCN       = FT(M)
        TEQ       = RT(M)
        MUL       = NMUL(M)
        DO N      = 1,NSP
          I         = (N-1)*NSS+II
          J         = (N-1)*NSS+JJ
          K         = (N-1)*NSS+KK
          L         = (N-1)*NSS+LL
*      if(n.eq.1) print *,'torsio  ',nam(i),nam(j),nam(k),nam(l)
*
          ax        = sx(j)-sx(i)
          ay        = sy(j)-sy(i)
          az        = sz(j)-sz(i)
          bx        = sx(k)-sx(j)
          by        = sy(k)-sy(j)
          bz        = sz(k)-sz(j)
          cx        = sx(l)-sx(k)
          cy        = sy(l)-sy(k)
          cz        = sz(l)-sz(k)
*
          call PBC(AX,AY,AZ)
          call PBC(BX,BY,BZ)
          call PBC(CX,CY,CZ)
*
          ab        = ax*bx + ay*by + az*bz
          bc        = bx*cx + by*cy + bz*cz
          ac        = ax*cx + ay*cy + az*cz
          at        = ax*ax + ay*ay + az*az
          bt        = bx*bx + by*by + bz*bz
          ct        = cx*cx + cy*cy + cz*cz

          axb       = (at*bt)-(ab*ab)
          bxc       = (bt*ct)-(bc*bc)
*
          fnum      = (ab*bc)-(ac*bt)
          den       = axb*bxc
*
          if(den.gt.0.0d0) then 
*
            den       = dsqrt(den)         
Cosine of angle:
            co        = fnum/den
            CO        = DMIN1(CO, 1.D0)
            CO        = DMAX1(CO,-1.D0)
* Sign of angle:
      signum    = ax*(by*cz-cy*bz)+ay*(bz*cx-cz*bx)+az*(bx*cy-cx*by)
* Value of angle:
            arg       = dsign(dacos(co),signum)
            si        = dsin(arg)
            if( dabs(si).lt.1.0d-12 ) si = dsign(1.0d-12,si)
*
*  For different types of torsion angles:
*
*   ---------------------------------------------
*   6.4.1  Normal AMBER-type torsion angle 
          if(ITORS(M).eq.0)then
            FCN       = FT(M)
            TEQ       = RT(M)
            MUL       = NMUL(M)
            EARG      = MUL*ARG-TEQ
            POTT      = FCN*(1.D0+DCOS(EARG))  
            DERI      = -FCN*MUL*DSIN(EARG)
*   6.4.2 MM3 force field torsional angle
	  else if(ITORS(M).eq.1)then
            FN1   = FT1(M)
            FN2   = FT2(M)
            FN3   = FT3(M)  
	    COS1F = dcos(ARG)
            COS2F =  2.D0*COS1F**2-1.D0
            COS3F = COS1F*(2.D0*COS2F-1.D0)
	    SIN2F = 2.d0*SIN1F*COS1F
	    SIN3F = SIN1F*COS2F+SIN2F*COS1F
            POTT  = FN1 * (1.D0 + COS1F)
     X             +FN2 * (1.D0 - COS2F)
     X             +FN3 * (1.D0 + COS3F)  
	    DERI	= -FN1*SIN1F+2.d0*FN2*SIN2F-3.d0*FN3*SIN3F
*   6.4.3            torsional angle 
	  else if(ITORS(M).eq.5)then  
	    FN0   = FT(M)
            FN1   = FT1(M)
            FN2   = FT2(M)
            FN3   = FT3(M)  
            FN4   = FT4(M)
            FN5   = FT5(M)
            TEQ   = RT(M)
            EARG  = ARG-TEQ
            COSI      =  DCOS(EARG)
            COSI2     =  COSI*COSI
            COSI3     =  COSI*COSI2
            COSI4     =  COSI*COSI3
            COSI5     =  COSI*COSI4
	    SINI	=  dsin(EARG)
            POTT =    FN0+ FN1*COSI+FN2*COSI2+     FN3*COSI3+
     +                              FN4*COSI4+     FN5*COSI5 
	    DERI =  -SINI*(FN1+2.d0*FN2*COSI +3.d0*FN3*COSI2+
     +                         4.d0*FN4*COSI3+5.d0*FN5*COSI4)
*   6.4.4 Improper dihedral angle
	  else if(ITORS(M).eq.-1)then                        
            FCN       = FT(M)
            TEQ       = RT(M)
            EARG      = ARG-TEQ
            POTT      = FCN*EARG**2  
            DERI      = 2.d0*FCN*EARG
	  else
	    write(*,*)'  Torsion type ',ITORS(M),' not supported'
	    write(*,*)'  Torsion ',I,J,K,L,' on ',NAME(ITYP)
	    stop
          end if
*
*...Energies:
*
            TR(M)     = TR(M)+ARG
            TE(M)     = TE(M)+POTT
            PINT	= PINT+POTT
	  if(IPRINT.ge.9)write(*,*)I,J,K,L,ARG*TODGR,POTT/EFACT
*
*...Forces:
*
            HELP      = -FCN*MUL*DSIN(EARG)
            de1       = 1.0d0/den/si*HELP
            axb       = axb/den*co
            bxc       = bxc/den*co
*X
      dnum      =  cx*bt - bx*bc
      dden      = (ab*bx - ax*bt)*bxc
      FFI1      = (dnum  - dden) * de1
      dnum      = ((bx-ax)*bc - ab*cx ) + (2.0*ac*bx - cx*bt)
      dden      = axb*(bc*cx-bx*ct) + (ax*bt-at*bx-ab*(bx-ax))*bxc
      FFJ1      = (dnum - dden) * de1
      dnum      = ab*bx - ax*bt
      dden      = axb*( bt*cx - bc*bx )
      FFL1      = (dnum - dden) * de1
      FFK1      = -(ffi1+ffj1+ffl1)
*
      HX(I)     = HX(I)+ffi1
      HX(J)     = HX(J)+ffj1
      HX(K)     = HX(K)+ffk1
      HX(L)     = HX(L)+ffl1
*Y
      dnum      =  cy*bt - by*bc
      dden      = (ab*by - ay*bt)*bxc
      FFI2      = (dnum  - dden) * de1
      dnum      = ((by-ay)*bc - ab*cy ) + (2.0*ac*by - cy*bt)
      dden      = axb*(bc*cy-by*ct) + (ay*bt-at*by-ab*(by-ay))*bxc
      FFJ2      = (dnum - dden) * de1
      dnum      = ab*by - ay*bt
      dden      = axb*( bt*cy - bc*by )
      FFL2      = (dnum - dden) * de1
      FFK2      = -(ffi2+ffj2+ffl2)
      HY(I)     = HY(I)+ffi2
      HY(J)     = HY(J)+ffj2
      HY(K)     = HY(K)+ffk2
      HY(L)     = HY(L)+ffl2
*Z
      dnum      =  cz*bt - bz*bc
      dden      = (ab*bz - az*bt)*bxc
      FFI3      = (dnum  - dden) * de1
      dnum      = ((bz-az)*bc - ab*cz ) + (2.0*ac*bz - cz*bt)
      dden      = axb*(bc*cz-bz*ct) + (az*bt-at*bz-ab*(bz-az))*bxc
      FFJ3      = (dnum - dden) * de1
      dnum      = ab*bz - az*bt
      dden      = axb*( bt*cz - bc*bz )
      FFL3      = (dnum - dden) * de1
      FFK3      = -(ffi3+ffj3+ffl3)
      HZ(I)     = HZ(I)+ffi3
      HZ(J)     = HZ(J)+ffj3
      HZ(K)     = HZ(K)+ffk3
      HZ(L)     = HZ(L)+ffl3
*   6.5.4 Contributions to projections of virial
	  VIRFX  = VIRFX-(AX+BX)*FFI1-BX*FFJ1+CX*FFL1
	  VIRFY  = VIRFY-(AY+BY)*FFI2-BY*FFJ2+CY*FFL2
	  VIRFZ  = VIRFZ-(AZ+BZ)*FFI3-BZ*FFJ3+CZ*FFL3
*
          endif ! den>0
        END DO! OF N
      END DO! OF M
*
      DO M      = NTBEG,NTEND
        TT(M)     = TT(M)+TR(M)*FNSPI
        ET(M)     = ET(M)+TE(M)*FNSPI
      END DO
*
*
      timet	= timet+cputime(timet0)
      RETURN
      END
*
*=============== STRBND ===========================================
*
      SUBROUTINE STRBND(ITYP)
*      
* This routine calculates intramolecular forces for 
* triatomic molecules (like water)
*
      include "mdee.h"
*
      DIMENSION BS(NB),BE(NB)
*
*.... ANHARMONIC FLEXIBLE WATER MODEL:
*
      PARAMETER (AAP  = 2809.56D0 , BBP = 2809.56D0)
      PARAMETER (CCP  =  687.41D0 , DDP =   2.566D0)
      PARAMETER (EEP  = -884.63D0 , FFP = -884.63D0)
      PARAMETER (GGP  =  467.31D0 ,BBMA=1.3,BBSA=1.4  )
*
      IF(NSITS(ITYP).NE.3) STOP '!!! NOT A WATER MOLECULE'
      IF( IPOT(ITYP).GT.2) STOP '!!! IPOT.GT.2  - NOT SUPPORTED! '
*
      NBBEG    = IADB(ITYP)
      NBEND    = NBBEG+NRB(ITYP)-1
*
      I1       = NBBEG
      I2       = I1+1
      I3       = I2+1
*
      IBEG     = IADDR(ITYP)+1
      IEND     = IADDR(ITYP+1)
      NSP      = NSPEC(ITYP)
      NSS      = NSITS(ITYP)
      FNSPI    = 1.D0/DFLOAT(NSP)
      FACT     = 1.D3/AVSNO/UNITE
      FACTOR   = FACT
*
      ROH1     = RB(I1)
      ROH2     = RB(I2)
      RH1H2    = RB(I3)
*
      AAA      = AAP*FACTOR
      BBB      = BBP*FACTOR
      DDD      = DDP
      IPT      = IPOT(ITYP)
      IF(IPT.EQ.2) THEN
        AAA      = AAA/DDD**2
        BBB      = BBB/DDD**2
      END IF
*
      CCC      = CCP*FACTOR
      EEE      = EEP*FACTOR
      FFF      = FFP*FACTOR
      GGG      = GGP*FACTOR
      BBM	= BBMA
      BBS	= BBSA
*
      EFAC     =  FKCALJ*1.D+3/AVSNO/UNITE
*
      DO M     = NBBEG,NBEND
      BS(M)    = 0.D0
      BE(M)    = 0.D0
      END DO
*
      AADD     = AAA*DDD
      BBDD     = BBB*DDD
*
      ISHF     = ISADDR(ITYP)
      IBB      = ISHF+1
      JBB      = ISHF+2
      KBB      = ISHF+3
*
      IF(IPOT(ITYP).EQ.2) THEN
*
      DO N     = 1,NSP
      I        = (N-1)*NSS+IBB
      J        = (N-1)*NSS+JBB
      K        = (N-1)*NSS+KBB 
*
      AX       = SX(J)-SX(I)
      AY       = SY(J)-SY(I)
      AZ       = SZ(J)-SZ(I)
*
      BX       = SX(K)-SX(I)
      BY       = SY(K)-SY(I)
      BZ       = SZ(K)-SZ(I)
*
      CX       = SX(K)-SX(J)
      CY       = SY(K)-SY(J)
      CZ       = SZ(K)-SZ(J)
*
      call PBC(AX,AY,AZ)
      call PBC(BX,BY,BZ)
      call PBC(CX,CY,CZ)
      RRA      = AX*AX+AY*AY+AZ*AZ
      RRB      = BX*BX+BY*BY+BZ*BZ
      RRC      = CX*CX+CY*CY+CZ*CZ
      ASS      = DSQRT(RRA)
      BSS      = DSQRT(RRB)
      if(ASS.gt.BBS)write(*,*)' !!! bond length ',ASS,' for ',I,J
      if(BSS.gt.BBS)write(*,*)' !!! bond length ',BSS,' for ',I,K
      CSS      = DSQRT(RRC)
      COSA     = (AX*BX+AY*BY+AZ*BZ)/ASS/BSS
      ARG      = DACOS(COSA)
*
      SA       = ASS-ROH1
      SB       = BSS-ROH2
      SH       = CSS-RH1H2
*
      EXPA     = DEXP(-DDD*SA)
      EXPAM    = 1.D0-EXPA
      EXPB     = DEXP(-DDD*SB)
      EXPBM    = 1.D0-EXPB
*
      WB1       = AAA*EXPAM**2+EEE*SA*SH
      WB2       = BBB*EXPBM**2+FFF*SB*SH
      WB3       = CCC*SH*SH   +GGG*SA*SB
      WB        = WB1+WB2+WB3
*
      BS(I1)    = BS(I1)+ASS
      BS(I2)    = BS(I2)+BSS
      BS(I3)    = BS(I3)+CSS
*!    BS(I3)    = BS(I3)+ARG
*
      BE(I1)    = BE(I1)+WB1
      BE(I2)    = BE(I2)+WB2
      BE(I3)    = BE(I3)+WB3 
	EWB	= WB1+WB2+WB3
      PINT	= PINT+EWB
*	if(IPRINT.ge.7)write(*,'(I5,f13.5,3f10.5)')
*     +N,0.001*EWB*ENERF,ASS,BSS,CSS
*
      if(ASS.gt.BBM)then
        FB3A	= -2.*SA*AADD*DDD
      else
        FB3A	= -2.*AADD*EXPA*EXPAM
      end if
      FB3A     = FB3A   - EEE*SH-GGG*SB
      if(BSS.gt.BBM)then
        FB3B	= -2.*SB*BBDD*DDD
      else
        FB3B	= -2.*BBDD*EXPB*EXPBM
      end if
      FB3B     = FB3B   - FFF*SH-GGG*SA
      FB3C     = -2.0*CCC*SH            - EEE*SA-FFF*SB
*
      FB3A     = FB3A/ASS
      FB3B     = FB3B/BSS
      FB3C     = FB3C/CSS
*
      AXX       = FB3A*AX
      AYY       = FB3A*AY
      AZZ       = FB3A*AZ
*
      BXX       = FB3B*BX
      BYY       = FB3B*BY
      BZZ       = FB3B*BZ
*
      CXX       = FB3C*CX
      CYY       = FB3C*CY
      CZZ       = FB3C*CZ
*
      HX(I)    = HX(I)-AXX-BXX
      HY(I)    = HY(I)-AYY-BYY
      HZ(I)    = HZ(I)-AZZ-BZZ
*
      HX(J)    = HX(J)+AXX   -CXX
      HY(J)    = HY(J)+AYY   -CYY
      HZ(J)    = HZ(J)+AZZ   -CZZ
*
      HX(K)    = HX(K)   +BXX+CXX
      HY(K)    = HY(K)   +BYY+CYY
      HZ(K)    = HZ(K)   +BZZ+CZZ
*  7.3.6  Virial calculations
	VIX	= AX*AXX + BX*BXX + CX*CXX
	VIY	= AY*AYY + BY*BYY + CY*CYY
	VIZ	= AZ*AZZ + BZ*BZZ + CZ*CZZ
	VIRB	= VIRB + VIX+VIY+VIZ
	VIRFX	= VIRFX+VIX
	VIRFY	= VIRFY+VIY
	VIRFZ	= VIRFZ+VIZ
*
      END DO! OF N
*
      ELSE
*
      DO N     = 1,NSP
      I        = (N-1)*NSS+IBB
      J        = (N-1)*NSS+JBB
      K        = (N-1)*NSS+KBB
*
      AX       = SX(J)-SX(I)
      AY       = SY(J)-SY(I)
      AZ       = SZ(J)-SZ(I)
*
      BX       = SX(K)-SX(I)
      BY       = SY(K)-SY(I)
      BZ       = SZ(K)-SZ(I)
*
      CX       = SX(K)-SX(J)
      CY       = SY(K)-SY(J)
      CZ       = SZ(K)-SZ(J)
      call PBC(AX,AY,AZ)
      call PBC(BX,BY,BZ)
      call PBC(CX,CY,CZ)
*
      RRA      = AX*AX+AY*AY+AZ*AZ
      RRB      = BX*BX+BY*BY+BZ*BZ
      RRC      = CX*CX+CY*CY+CZ*CZ
*
      ASS      = DSQRT(RRA)
      BSS      = DSQRT(RRB)
      CSS      = DSQRT(RRC)
      COSA     = (AX*BX+AY*BY+AZ*BZ)/ASS/BSS
      ARG      = DACOS(COSA)
*
      SA       = ASS-ROH1
      SB       = BSS-ROH2
      SH       = CSS-RH1H2
*
      WB1      = AAA*SA*SA+EEE*SA*SH
      WB2      = BBB*SB*SB+FFF*SB*SH 
      WB3      = CCC*SH*SH+GGG*SA*SB
      WB       = WB1+WB2+WB3
*
      BS(I1)    = BS(I1)+ASS
      BS(I2)    = BS(I2)+BSS
      BS(I3)    = BS(I3)+CSS
*!    BS(I3)    = BS(I3)+ARG
*
      BE(I1)    = BE(I1)+WB1
      BE(I2)    = BE(I2)+WB2
      BE(I3)    = BE(I3)+WB3
      PINT	= PINT+WB1+WB2+WB3
*
      FB3A     = -2.0*AAA*SA - EEE*SH-GGG*SB
      FB3B     = -2.0*BBB*SB - FFF*SH-GGG*SA
      FB3C     = -2.0*CCC*SH - EEE*SA-FFF*SB
*
      FB3A     = FB3A/ASS
      FB3B     = FB3B/BSS
      FB3C     = FB3C/CSS
*
      AXX       = FB3A*AX
      AYY       = FB3A*AY
      AZZ       = FB3A*AZ
*
      BXX       = FB3B*BX
      BYY       = FB3B*BY
      BZZ       = FB3B*BZ
*
      CXX       = FB3C*CX
      CYY       = FB3C*CY
      CZZ       = FB3C*CZ
*
      HX(I)    = HX(I)-AXX-BXX
      HY(I)    = HY(I)-AYY-BYY
      HZ(I)    = HZ(I)-AZZ-BZZ
*
      HX(J)    = HX(J)+AXX   -CXX
      HY(J)    = HY(J)+AYY   -CYY
      HZ(J)    = HZ(J)+AZZ   -CZZ
*
      HX(K)    = HX(K)   +BXX+CXX
      HY(K)    = HY(K)   +BYY+CYY
      HZ(K)    = HZ(K)   +BZZ+CZZ
*
*  7.4.6 Virial calculations                      
	VIX	= AX*AXX + BX*BXX + CX*CXX
	VIY	= AY*AYY + BY*BYY + CY*CYY
	VIZ	= AZ*AZZ + BZ*BZZ + CZ*CZZ
	VIRB	= VIRB + VIX+VIY+VIZ
	VIRFX	= VIRFX+VIX
	VIRFY	= VIRFY+VIY
	VIRFZ	= VIRFZ+VIZ
      END DO! OF N
*
      END IF
*
      DO M      = NBBEG,NBEND
      BB(M)     = BB(M)+BS(M)*FNSPI
      EB(M)     = EB(M)+BE(M)*FNSPI
      END DO! OF M
*      print *,bs(1)*fnspi
*     X       ,bs(2)*fnspi
*     X       ,bs(3)*fnspi
*
	RETURN
      END
*
*=============== SLOW FORCES =============================================
*
      SUBROUTINE FORCES
*
*  LJ and Re-part of electrostatic interactions
*
      include "mdee.h"
*
      timel0	= cputime(0.d0)
      DO N         = 1,NSTOT
        FX(N)        = 0.D0
        FY(N)        = 0.D0
        FZ(N)        = 0.D0
        OX(N)        = 0.D0
        OY(N)        = 0.D0
        OZ(N)        = 0.D0
      END DO! OF N 
*
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1) RETURN
*
*
* Sum over atom pairs
      DO INP      = 1,MBLN
 	ISP0=NBL1(INP)
	JSP=NBL2(INP)
        ISP=iabs(ISP0)
	ITYP=ITYPE(ISP)
	JTYP=ITYPE(JSP)
	ISB =NSITE(ISP)
  	JSB =NSITE(JSP)
        IMOL=NNUM(ISP)
        JMOL=NNUM(JSP)
	MTR=MDX(ITYP,JTYP)
	if(ISP0.le.0)then  
* signals that this pair is 1-4 neigbours
	  if(ITYP.ne.JTYP)write(*,*)
     +'!!! different mol. types for 1-4 interaction:',
     +ITYP,JTYP,ISP,JSP,' FF'
	  FCTLJ=C14LJ(ITYP)
*   8.2.1 special 1-4 interactions
c   Look through the list of special 1-4 interactions
C   and check whether this pair belong to it
C   This procedure may seem cumbersobe, but I didnot find better way
C   without using (NSITES,NSITES) array. Really this is not very
C   time-consuming; saving memory is preferable
	  do I=1,NNAD 
	    ILA=ILJ(I)
	    if(ILA.eq.ISB)then  
	      do J=1,NNAD 
	        JLA=ILJ(J)
	        if(JLA.eq.JSB)then
                  EPSI       =  EPAD(I)*EPAD(J)
                  SIGM       =  SIGAD(I)+SIGAD(J)
                  go to 195
	        end if
	      end do
              EPSI       =  EPAD(I)*EPSIL(JSB)
              SIGM       =  SIGAD(I)+SIGMA(JSB)
              go to 195
	    end if
	  end do
	  do J=1,NNAD
	    JLA=ILJ(J)
	    if(JLA.eq.JSB)then
              EPSI       =  EPSIL(ISB)*EPAD(J)
              SIGM       =  SIGMA(ISB)+SIGAD(J)
              go to 195
	    end if
	  end do
*   8.2.2  Normal LJ for 1-4 connected pairs
C
C   Note: EPSIL here, above and below is really sqrt(epsil) in LJ potential
C  (see also setup.f )
C
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM       =  SIGMA(ISB)+SIGMA(JSB)
 195      continue 
          A6         = -EPSI*SIGM**6*FCTLJ    
          B12       =  EPSI*SIGM**12*FCTLJ    
  	  QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF*C14EL(ITYP)
*   8.2.3 Not 1-4 neigbours
	else  ! if(ISP0
*  the same molecule - not scale in EE
          if(IMOL.eq.JMOL)then
            EPSI       =  EPS(ISB,JSB)
            SIGM       =  SIG(ISB,JSB)
            A6         = -EPSI*SIGM**6
            B12        =  EPSI*SIGM**12
            QIJ        =  CHARGE(ISB)*CHARGE(JSB)*COULF
*  scaled parameters defined in RECINT
          else
  	    A6=SIX(ISB,JSB)
	    B12=TWL(ISB,JSB)
	    QIJ=ONE(ISB,JSB)
          end if
        end if   ! if(ISPO...
        DX           = SX(ISP)-SX(JSP)
        DY           = SY(ISP)-SY(JSP)
        DZ           = SZ(ISP)-SZ(JSP)
*                  call PBC(DX,DY,DZ)
        if(DX.gt. HBOXL)DX=DX-BOXL
        if(DX.lt.-HBOXL)DX=DX+BOXL
        if(DY.gt. HBOYL)DY=DY-BOYL
        if(DY.lt.-HBOYL)DY=DY+BOYL
        if(DZ.gt. HBOZL)DZ=DZ-BOZL
        if(DZ.lt.-HBOZL)DZ=DZ+BOZL
*  
	RR           = DX**2+DY**2+DZ**2
        R1           = DSQRT(RR)
C        if(R1.le.3..and.(ISP.eq.12.or.JSP.eq.12))
C     +write(*,*)'F- long ',R1,' atoms ',ISP,JSP
        R2I          = 1.0D0/RR
	R1I	   = R1*R2I
*  Electrostatic interaction
        ALPHAR       = ALPHAD*R1
	TTT          = 1.D0/(1.D0+B1*ALPHAR)
        EXP2A        = DEXP(-ALPHAR**2)
        ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A 
	EE1	= QIJ*R1I
*  LJ interaction
        R6I          = R2I*R2I*R2I
        ESR          = (     A6+      B12*R6I)*R6I
        FSR          = (6.D0*A6+12.D0*B12*R6I)*R6I*R2I
	if(IMOL.eq.JMOL)then 
C   This can not happen for different molecules... 
C   Scaling constant from the input 
          if(ISP0.le.0)then
	    EES=EE1
            FES=EES*R2I
          else
            FES          = QIJ*(TOTPI*ALPHAR*EXP2A+ERFC)*R1I*R2I
            EES          = EE1*ERFC
          end if
        else   ! normal case
          FES          = QIJ*(TOTPI*ALPHAR*EXP2A+ERFC)*R1I*R2I
          EES          = EE1*ERFC
	end if
        FORCE        = FES+FSR
*  Forces
          FX(ISP)      = FX(ISP)+FORCE*DX
          FY(ISP)      = FY(ISP)+FORCE*DY
          FZ(ISP)      = FZ(ISP)+FORCE*DZ
          FX(JSP)      = FX(JSP)-FORCE*DX
          FY(JSP)      = FY(JSP)-FORCE*DY
          FZ(JSP)      = FZ(JSP)-FORCE*DZ
          VIR1	 = VIR1+FSR*RR
	  if(IMOL.ne.JMOL.or.LMOVE(ITYP))then
	    VIRX	= VIRX+FORCE*DX**2  
	    VIRY	= VIRY+FORCE*DY**2  
	    VIRZ	= VIRZ+FORCE*DZ**2  
	  end if
	  POTES(MTR)   = POTES(MTR)+EE1
	  POTLJ(MTR)   = POTLJ(MTR)+ESR
	  PELS1=PELS1+EES
          PE1 = PE1+ESR
*
      END DO! OF INP					
*
*     print *,'potes(1)',potes(1)*enerf*1.d-3/256.
*     print *,'potlj(1)',potlj(1)*enerf*1.d-3/256.
*     print *,'potes(2)',potes(2)*enerf*1.d-3/256.
*     print *,'potlj(2)',potlj(2)*enerf*1.d-3/256.
*     print *,'potes(3)',potes(3)*enerf*1.d-3/256.
*     print *,'potlj(3)',potlj(3)*enerf*1.d-3/256.
*
*Accumulate total forces
*
      DO N         = 1,NSTOT
	M	= NNUM(N)
        GX(N)        = GX(N)+FX(N)
        GY(N)        = GY(N)+FY(N)
        GZ(N)        = GZ(N)+FZ(N)
	WIRS	= WIRS-GX(N)*(SX(N)-X(M))-GY(N)*(SY(N)-Y(M))-
     +               GZ(N)*(SZ(N)-Z(M))
      END DO! OF N
      timel	= timel+cputime(timel0)
*
      RETURN
      END
*
*======================= LOCALF ==========================================
*
      SUBROUTINE LOCALF
*
*  LJ and electrostatic interactions of closest neigbours
*
      include "mdee.h"
*
      times0	= cputime(0.d0)
      DO N         = 1,NSTOT
        FX(N)        = 0.D0
        FY(N)        = 0.D0
        FZ(N)        = 0.D0
      END DO! OF N
*
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1) RETURN
*
* Sum over atom pairs
      EEE=0.
      ELJ=0.
      DO INP      = 1,MBSH
	ISP0=NBS1(INP)
	JSP=NBS2(INP)
        ISP=iabs(ISP0)
	ITYP=ITYPE(ISP)
	JTYP=ITYPE(JSP)
	ISB =NSITE(ISP)
  	JSB =NSITE(JSP)
        IMOL=NNUM(ISP)
        JMOL=NNUM(JSP)
	MTR=MDX(ITYP,JTYP)
	if(ISP0.le.0)then  
* signals that this pair is 1-4 neigbours
	  if(ITYP.ne.JTYP)write(*,*)
     +'!!! different mol. types for 1-4 interaction:',
     +ITYP,JTYP,ISP,JSP,' FF'
	  FCTLJ=C14LJ(ITYP)
*   9.2.1 special 1-4 interactions
c   Look through the list of special 1-4 interactions
C   and check whether this pair belong to it
C   This procedure may seem cumbersobe, but I didnot find better way
C   without using (NSITES,NSITES) array. Really this is not very
C   time-consuming; saving memory is preferable
	  do I=1,NNAD 
	    ILA=ILJ(I)
	    if(ILA.eq.ISB)then  
	      do J=1,NNAD 
	        JLA=ILJ(J)
	        if(JLA.eq.JSB)then
                  EPSI       =  EPAD(I)*EPAD(J)
                  SIGM       =  SIGAD(I)+SIGAD(J)
                  go to 195
	        end if
	      end do
              EPSI       =  EPAD(I)*EPSIL(JSB)
              SIGM       =  SIGAD(I)+SIGMA(JSB)
              go to 195
	    end if
	  end do
	  do J=1,NNAD
	    JLA=ILJ(J)
	    if(JLA.eq.JSB)then
              EPSI       =  EPSIL(ISB)*EPAD(J)
              SIGM       =  SIGMA(ISB)+SIGAD(J)
              go to 195
	    end if
	  end do
*   8.2.2  Normal LJ for 1-4 connected pairs
C
C   Note: EPSIL here, above and below is really sqrt(epsil) in LJ potential
C  (see also setup.f )
C
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM       =  SIGMA(ISB)+SIGMA(JSB)
 195      continue 
          A6         = -EPSI*SIGM**6*FCTLJ    
          B12       =  EPSI*SIGM**12*FCTLJ    
  	  QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF*C14EL(ITYP)
*   9.2.3 Not 1-4 neigbours
	else  ! if(ISP0
*  the same molecule - not scale in EE
          if(IMOL.eq.JMOL)then
            EPSI       =  EPS(ISB,JSB)
            SIGM       =  SIG(ISB,JSB)
            A6         = -EPSI*SIGM**6
            B12        =  EPSI*SIGM**12
            QIJ        =  CHARGE(ISB)*CHARGE(JSB)*COULF
*  scaled parameters defined in RECINT
          else
  	    A6=SIX(ISB,JSB)
	    B12=TWL(ISB,JSB)
	    QIJ=ONE(ISB,JSB)
          end if
        end if   ! if(ISPO...
*
*   9.2 Calculate interaction parameters for the given atom pair 
*   ------------------------------------------------------------
        DX           = SX(ISP)-SX(JSP)
        DY           = SY(ISP)-SY(JSP)
        DZ           = SZ(ISP)-SZ(JSP)
*                  call PBC(DX,DY,DZ)
        if(DX.gt. HBOXL)DX=DX-BOXL
        if(DX.lt.-HBOXL)DX=DX+BOXL
        if(DY.gt. HBOYL)DY=DY-BOYL
        if(DY.lt.-HBOYL)DY=DY+BOYL
        if(DZ.gt. HBOZL)DZ=DZ-BOZL
        if(DZ.lt.-HBOZL)DZ=DZ+BOZL
*  
	RR           = DX**2+DY**2+DZ**2
        R1           = DSQRT(RR)
C        if(R1.le.3..and.(ISP.eq.12.or.JSP.eq.12))
C     +write(*,*)'F- short ',R1,' atoms ',ISP,JSP
          R2I          = 1.0D0/RR
	  R1I	   = R1*R2I
*  Electrostatic interaction
          ALPHAR       = ALPHAD*R1
	  TTT          = 1.D0/(1.D0+B1*ALPHAR)
          EXP2A        = DEXP(-ALPHAR**2)
          ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A 
	  EE1	= QIJ*R1I
	  if(ISP0.le.0)then 
C   This can not happen for different molecules... 
            EES=EE1
            FORCE=EES*R2I
          else
            FORCE        = QIJ*(TOTPI*ALPHAR*EXP2A+ERFC)*R1I*R2I
            EES          = EE1*ERFC
	  end if
	  POTES(MTR)    = POTES(MTR)+EE1
	  PELS2=PELS2+EES
*  LJ interaction
	  if(A6.ne.0.d0.or.B12.ne.0.d0)then
            R6I          = R2I*R2I*R2I
            ESR          = (     A6+      B12*R6I)*R6I
            FSR          = (6.D0*A6+12.D0*B12*R6I)*R6I*R2I
	      FORCE        = FORCE+FSR
              VIR2		= VIR2+FSR*RR
	      POTLJ(MTR)    = POTLJ(MTR)+ESR
	      PE2		= PE2+ESR
	     end if     
*        write(*,'(4i5,5e11.4)')ISP0,JSP,ISB,JSB,R1,ESR,EES,PE
*  Forces
        FX(ISP)      = FX(ISP)+FORCE*DX
        FY(ISP)      = FY(ISP)+FORCE*DY
        FZ(ISP)      = FZ(ISP)+FORCE*DZ
        FX(JSP)      = FX(JSP)-FORCE*DX
        FY(JSP)      = FY(JSP)-FORCE*DY
        FZ(JSP)      = FZ(JSP)-FORCE*DZ
	VIRFX	= VIRFX+FORCE*DX**2  
	VIRFY	= VIRFY+FORCE*DY**2  
	VIRFZ	= VIRFZ+FORCE*DZ**2  
*
      END DO! OF INP
      PERMOL=0.001*ENERF / NOP
*
*Accumulate total forces
*
      DO N         = 1,NSTOT
	M	= NNUM(N)
        HX(N)        = HX(N)+FX(N)
        HY(N)        = HY(N)+FY(N)
        HZ(N)        = HZ(N)+FZ(N)
        WIRSS	= WIRSS-HX(N)*(SX(N)-X(M))-HY(N)*(SY(N)-Y(M))-
     +               HZ(N)*(SZ(N)-Z(M))
      END DO! OF N
      VIRS=VIRS+VIR1
      VIRLS=VIRLS+VIR1
      times	= times+cputime(times0)
*
      RETURN
      END 
*
*=============== FURIR =======================================
*
      SUBROUTINE FURIR
*
      include "mdee.h"
      real*8 TSIN(NTOT),TCOS(NTOT)
*                                       
	timef0	= cputime(0.d0)
*
      call INIFUR
*
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1) RETURN
	if(NKV.eq.0)return
*
      QSS         = 0.D0
      DO ITYP     = 1,NTYPES
        QSS         = QSS+QSUM(ITYP)
      END DO! OF ITYP
      IF(QSS.EQ.0.D0) RETURN
*
      QPE         = 0.D0
      CFUR=4.d0*PI*COULF/VOL     
*
      DO I        = 1,NSTOT
	  FX(I)=0.d0
	  FY(I)=0.d0
	  FZ(I)=0.d0
      END DO! OF I
*   reciprocal space Evald
      do IKV=1,NKV
        RXV=RX(IKV)
        RYV=RY(IKV)
        RZV=RZ(IKV)
        SCS=0.
        SSN=0.
C$DIR NO_RECURRENCE
        do I=1,NSTOT
          SCP=RXV*SX(I)+RYV*SY(I)+RZV*SZ(I)
          ITYP=ITYPE(I)
          IC=NSITE(I)
	  if(IEE(ITYP).eq.0)then
	      QO=CHARGE(IC)*EC(ME)
	  else
	      QO=CHARGE(IC)
	  end if
*  sin and cos from tables
          SINSC=QO*sin(SCP)
          COSSC=QO*cos(SCP)
          TSIN(I)=SINSC
          TCOS(I)=COSSC
          SSN=SSN+SINSC
          SCS=SCS+COSSC
        end do
        AKC=CFUR*AK(IKV)
        QPE=QPE+AKC*(SSN**2+SCS**2)
        AK2=2.d0*AKC
        do I=1,NSTOT
          QFOR=AK2*(SCS*TSIN(I)-SSN*TCOS(I))
          FX(I)=FX(I)+RXV*QFOR
          FY(I)=FY(I)+RYV*QFOR
          FZ(I)=FZ(I)+RZV*QFOR
        end do
	VIRX=VIRX-RXV**2*AKV*(SSN**2+SCS**2) 
	VIRY=VIRY-RYV**2*AKV*(SSN**2+SCS**2)
	VIRZ=VIRZ-RZV**2*AKV*(SSN**2+SCS**2)
      end do      
      DO I     = 1,NSTOT
        GX(I)    = GX(I)+FX(I)
        GY(I)    = GY(I)+FY(I)
        GZ(I)    = GZ(I)+FZ(I)
        IMOL	= NNUM(I)
        WIR1	= WIR1-FX(I)*(SX(I)-X(IMOL))-FY(I)*(SY(I)-Y(IMOL))-
     +               FZ(I)*(SZ(I)-Z(IMOL))
      END DO! OF I
*
      VIRX=VIRX+QPE
      VIRY=VIRY+QPE
      VIRZ=VIRZ+QPE
      PELS1=PELS1+QPE
      FACTR=  0.001*ENERF/FNOP
*	if(IPRINT.ge.7)write(*,'(a,4f12.5)')
*     +' FUR_TRUE:',FACTR*QPE
      timef	= timef+cputime(timef0)
      return
      end
*
*================= INIFUR =========================================
*
      subroutine INIFUR
      include "mdee.h"
      data INIT/0/
      if(INIT.ne.0)return 
        INIT=1
	if(ALPHAD.eq.0.d0)then
	  NKV=0
	  return
      end if    
      ALP2=ALPHAD**2
      CUTK2=4.d0*ALP2*FEXP
	CUTK=sqrt(CUTK2)
      FKX=2.d0*PI/BOXL
      FKY=2.d0*PI/BOYL
      FKZ=2.d0*PI/BOZL
      IKV=0
	KMAX=CUTK/FKX+1
	KMAY=CUTK/FKY+1
	KMAZ=CUTK/FKZ+1
      do IKZ=-KMAZ,KMAZ
        do IKX=0,KMAX
          if(IKX.eq.0)then
            if(IKZ.gt.0)then
              KY1=0
            else
              KY1=1
            end if
            KY2=KMAY
          else
            KY1=-KMAY
            KY2=KMAY
          end if
          do IKY=KY1,KY2
            RK2=(IKX*FKX)**2+(IKY*FKY)**2+(IKZ*FKZ)**2
            if(RK2.le.CUTK2)then
      	      IKV=IKV+1
              if(IKV.gt.NKVMAX)stop 'increase NKVMAX'
              RX(IKV)=IKX*FKX
              RY(IKV)=IKY*FKY
              RZ(IKV)=IKZ*FKZ
              AK(IKV)=exp(-0.25d0*RK2/ALP2)/RK2
            end if
          end do
        end do
      end do      
      NKV=IKV
      write(*,*)'Ewald sum:  Kmax=',KMAX,'   Num. of k-vectors ',NKV
      return	
      end 
*   12.  Calculation of self-interaction term in the Ewald sum
*   ----------------------------------------------------------
C
C   Really this procedure calculates two terms:
C   1) Standard self-interaction Ewald term, giving only constant 
C   contribution to the energy
C   2) "Molecular correction" which is due to the fact, that bound
C   atoms in a molecule do not interact electrostatically, but 
C   reciprocal Ewald term includes these interactions also.
*
*============= ETERMS =================================================
*
      SUBROUTINE ETERMS
*  12.1 Front matter
      include "mdee.h"         
      real*8 SPEEI(NTPS)
      data INIT/0/  
*      save SPEEI,SPEI,ABC,INIT
      timee0	= cputime(0.d0)
      if(LMNBL)return
      WIR1=0.
*
*  12.2  Electrostatic self-interaction
*  ------------------------------------
	INIT=1
        ABC = ALPHAD/DSQRT(PI)
	SPEI=0.
        do ITYP=1,NTYPES 
	  SPET=0.
	  do I=1,NSITS(ITYP)
	    IS=ISADR(ITYP)+I
  	    QII=ONE(IS,IS)
            SPET         = SPET-NSPEC(ITYP)*ABC*QII
	  end do         
	  SPET=SPET/NUMTASK
	  SPEEI(ITYP)=SPET
	  SPEI=SPEI+SPET
	end do
      do I=1,NTYPES
	SELFPE(I)=SPEEI(I)
      end do            
      SPE=SPEI
*
*  12.3  Calculate intramolecular correction
*  -----------------------------------------
*  12.3.1 Start cycle over bound atoms 
C  list of bound atoms is prepeared in BNDLST (setup.f)   
      IBEG=NUMTASK-TASKID 
      do ISP=IBEG,NSTOT,NUMTASK
	NSP = NNBB(ISP)
	do J=1,NSP
	  JSP=    INBB(ISP,J)
	  if(JSP.le.0)JSP=-JSP
	  if(ISP.gt.JSP)then  ! avoid double count!
	    IS	= NSITE(ISP)
	    JS	= NSITE(JSP)
	    ITYP  = ITYPE(ISP)
  	    QIJ = ONE(IS,JS)
            DX          = SX(ISP)-SX(JSP)
            DY          = SY(ISP)-SY(JSP)
            DZ          = SZ(ISP)-SZ(JSP)
*  12.3.2  Apply periodic boundary conditions
            if(DX.gt. HBOXL)DX=DX-BOXL
            if(DX.lt.-HBOXL)DX=DX+BOXL
	    if(LHEX)then
C  hexagonal periodic cell)
	      XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
              DY=DY-BOYL
              DX=DX-HBOXL
	      XY=BOXYC*DX
            end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
              DY=DY+BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.gt.BOXY3+XY)then
              DY=DY-BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.lt.-BOXY3+XY)then
              DY=DY+BOYL
              DX=DX-HBOXL
            end if
	    else                   
C  rectangular cell
              if(DY.gt. HBOYL)DY=DY-BOYL
              if(DY.lt.-HBOYL)DY=DY+BOYL
	    end if
            if(DZ.gt. HBOZL)DZ=DZ-BOZL
            if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	    if(LOCT)then
	      CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	      DX=DX-sign(CORSS,DX)
	      DY=DY-sign(CORSS,DY)
	      DZ=DZ-sign(CORSS,DZ)
	    end if
*	  call PBC(DX,DY,DZ)
*   12.3.3 Calculate contributions to energy and forces
            R2          = DX**2+DY**2+DZ**2
            R2I         = 1.D0/R2
            R1          = DSQRT(R2)
            R1I         = R1*R2I
            ALPHAR      = ALPHAD*R1
*  	          call RERFC(ALPHAR,ERFC,EXP2A)
            TTT         = 1.D0/(1.D0+B1*ALPHAR)
            EXP2A       = DEXP(-ALPHAR**2)
            ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A
            EES  = QIJ*(ERFC-1.d0)*R1I
            SPE         = SPE+EES
	    SELFPE(ITYP)  = SELFPE(ITYP)+EES
              FES  = QIJ*((TOTPI*ALPHAR*EXP2A+ERFC)-1.d0)*R1I*R2I
              GX(ISP)     = GX(ISP)+FES*DX
              GY(ISP)     = GY(ISP)+FES*DY
              GZ(ISP)     = GZ(ISP)+FES*DZ
              GX(JSP)     = GX(JSP)-FES*DX
              GY(JSP)     = GY(JSP)-FES*DY
              GZ(JSP)     = GZ(JSP)-FES*DZ
	      VIRX	= VIRX+FES*DX**2  
	      VIRY	= VIRY+FES*DY**2  
	      VIRZ	= VIRZ+FES*DZ**2
	  end if
	end do 
      END DO! OF I
      timee	= timee+cputime(timee0)
      RETURN
      END
*                 
*============= ELRCLJ =================================================
*
      SUBROUTINE ELRCLJ
*
*   long-range corrections to LJ energy and pressure
*
      include"mdee.h"
      data INIT/0/
*
      DO I        = 1,MOLINT
      PELRC(I)    = 0.D0
      VRLRC(I)    = 0.D0
      END DO! OF I
*
      RC          = DSQRT(RSSQ)
      DO 400 ITYP = 1    ,NTYPES
        ISBEG       = ISADR(ITYP)+1
        ISEND       = ISADR(ITYP +1)
        NSPI        = NSPEC(ITYP)
	if(IEE(ITYP).eq.0)then
	  ESCI=EC(ME)
	else
	  ESCI=1.d0
	end if
        DO 400   IS = ISBEG,ISEND
          DO 300 JTYP = ITYP ,NTYPES
            MT          = MDX  (ITYP,JTYP)
            JSBEG       = ISADR(JTYP)+1
            JSEND       = ISADR(JTYP +1)
            NSPJ        = NSPEC(JTYP)
            FNOPIJ      = DFLOAT(NSPI*NSPJ)
            if(ITYP.eq.JTYP)FNOPIJ=0.5*FNOPIJ
	    if(IEE(JTYP).eq.0)then
	      ESCJ=EC(ME)
	    else
	      ESCJ=1.d0
	    end if
            ESCL=ESCI*ESCJ
            DO 300   JS = JSBEG,JSEND
	      EP          = EPS(IS,JS)
              SI          = SIG(IS,JS)  
              PELRC(MT)   = ESCL*PELRC(MT)+EP*SI**3*
     X(( 1.D0/9.D0)*(SI/RC)**9 - ( 1.D0/3.D0)*(SI/RC)**3)*FNOPIJ
              VRLRC(MT)   = ESCL*VRLRC(MT)+EP*SI**3*
     X((-4.D0/3.D0)*(SI/RC)**9 + (      2.D0)*(SI/RC)**3)*FNOPIJ
  300     CONTINUE
  400 CONTINUE
*
      FCV	= UNITP/(3.*VOL)
      PELR	= 0.d0
      VIRD	= 0.d0     
      DO I      = 1,MOLINT
        PELRC(I)  = 4.*PI*PELRC(I)/VOL
        VRLRC(I)  = -4.*PI*VRLRC(I)/VOL
        PELR=PELR+PELRC(I)
        VIRD=VIRD+VRLRC(I)    
        if(INIT.eq.0.and.IPRINT.ge.6)then
          PRINT "('*** PE  LRC ',I2,': ',F12.8,' kJ/mol')",
     +    I,PELRC(I)*PERMOL
        PRINT "('*** PR  LRC ',I2,': ',F12.4,' atm   ')",I,VRLRC(I)*FCV
        end if
      END DO
      INIT=1
*
      RETURN
      END
*
C===========================================================================
*
*  15. Recalculation of list of neighbours
*  ---------------------------------------
C  This procedure calculate lists of closest and far neighbours
C  for subroutines LOCALF and FORCES
C  These lists must be recalculated after some time
C  Each node calculate goes through its own list of atom pairs 
C  and creates own lists, which are used in subroutines for force calculation
C
C================ CHCNB =======================================================
C     
      subroutine CHCNB(LRDF)
*  15.1 Front matter     
      include "mdee.h"
      logical LGRC,LRDF 
      parameter (RMX2=5.**2,MMOL=5)
      timev0	= cputime(0.d0)
      MBLN=0
      MBSH=0
      IOVER=0
      IESH=0
      LGRC=LGR.and.LRDF
      RDFCUT2=RDFCUT**2
*
*  15.2  Organize cycle over ALL atom pairs
*  ----------------------------------------
      IBEG=NUMTASK-TASKID 
C  cycle over I,J is organized is follows:
C  it takes I>J if I and J are of the same parity and I<J if I and J have
C  different parity. This allows nearly uniformly distribute atom pairs 
C  between the nodes
      do I=1,NSTOT
	IMOL=NNUM(I) 
	ITYP=ITYPE(I)
*   15.2.1 Even strips
*        do J=I-2,1,-2
        do J=1,I-1
	  JMOL=NNUM(J)
	  DX=SX(I)-SX(J)
	  DY=SY(I)-SY(J)
	  DZ=SZ(I)-SZ(J)
*   15.2.1.1 Periodic boundary conditions
C	    call PBC (DX,DY,DZ)
	  if(DX.gt. HBOXL)DX=DX-BOXL
          if(DX.lt.-HBOXL)DX=DX+BOXL
          if(DZ.gt. HBOZL)DZ=DZ-BOZL
          if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	    if(LHEX)then
C  hexagonal periodic cell)
	      XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
              DY=DY-BOYL
              DX=DX-HBOXL
	      XY=BOXYC*DX
            end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
              DY=DY+BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.gt.BOXY3+XY)then
              DY=DY-BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.lt.-BOXY3+XY)then
              DY=DY+BOYL
              DX=DX-HBOXL
            end if
	    else                   
C  rectangular cell
            if(DY.gt. HBOYL)DY=DY-BOYL
            if(DY.lt.-HBOYL)DY=DY+BOYL
	    end if
	    if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	      CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	      DX=DX-sign(CORSS,DX)
	      DY=DY-sign(CORSS,DY)
	      DZ=DZ-sign(CORSS,DZ)
	    end if                  
	    RR2=DX**2+DY**2+DZ**2  
*  15.2.1.2 Case of "molecular" cutoff - calculate COM distance
C  If we do not use Ewald summation (LMNBL=.true.), 
C  it is important that at least
C  small molecules (less than MMOL atoms) where inside or outside
C  cut-off radius as a whole 
	    if(LMNBL)then
	      NMI=NSITS(ITYP) 
	      NMJ=NSITS(ITYPE(J))
	      if(NMI.gt.MMOL.and.NMJ.gt.MMOL)then
		RRM=RR2
		go to 110
	      else if(NMI.gt.MMOL.and.NMJ.le.MMOL)then
	        DX=SX(I)-X(JMOL)
	        DY=SY(I)-Y(JMOL)
	        DZ=SZ(I)-Z(JMOL)
	      else if(NMJ.gt.MMOL)then
	        DX=X(IMOL)-SX(J)
	        DY=Y(IMOL)-SY(J)
	        DZ=Z(IMOL)-SZ(J)
	      else 
	        DX=X(IMOL)-X(JMOL)
	        DY=Y(IMOL)-Y(JMOL)
	        DZ=Z(IMOL)-Z(JMOL)
	      end if
*	      call PBC (DX,DY,DZ)
	      if(DX.gt. HBOXL)DX=DX-BOXL
              if(DX.lt.-HBOXL)DX=DX+BOXL
              if(DZ.gt. HBOZL)DZ=DZ-BOZL
              if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	      if(LHEX)then
C  hexagonal periodic cell)
	        XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
                DY=DY-BOYL
                DX=DX-HBOXL
	        XY=BOXYC*DX
              end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
                DY=DY+BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.gt.BOXY3+XY)then
                DY=DY-BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.lt.-BOXY3+XY)then
                DY=DY+BOYL
                DX=DX-HBOXL
              end if
	      else                   
C  rectangular cell
                if(DY.gt. HBOYL)DY=DY-BOYL
                if(DY.lt.-HBOYL)DY=DY+BOYL
	      end if
	      if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	        CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	        DX=DX-sign(CORSS,DX)
	        DY=DY-sign(CORSS,DY)
	        DZ=DZ-sign(CORSS,DZ)
	      end if                  
C  square distance betwen COM of small molecules
	      RRM=DX**2+DY**2+DZ**2 
	    else   ! .not.LMNBL
	      RRM=RR2              
	    end if
*  15.2.1.3 Check if the atoms are bound
 110	    if(IMOL.eq.JMOL)then    ! bound atoms should not be in the list
	      if(RR2.le.RMX2)then
C   Check that the atoms are non-bound. Check using binding list of the
C   atom which has less bound atoms, only for atoms with distance < RMX
	        if(NNBB(I).le.NNBB(J))then
		  do K=1,NNBB(I) 
C   1-3 bound:  not in the list
		    if(INBB(I,K).eq.J)go to 125
                    if(INBB(I,K).eq.-J.and.L14NB(ITYP))then
C   1-4 bound:  put into list with negative first index
C   (these atom pairs may have a special way of force calculations)
  	              MBSH=MBSH+1
	              if(MBSH.gt.NBSMAX)IESH=1
                      if(IESH.eq.0)then
	                NBS1(MBSH)=-I
		        NBS2(MBSH)=J
                      end if
*            write(*,'(a,2i5,f12.5,2i8)')'1-4s',I,J,sqrt(RR2),MBSH,MBLN
	              go to 125
		    end if  
	  	  end do
	        else
		  do K=1,NNBB(J) 
C   1-3 bound
		    if(INBB(J,K).eq.I)go to 125
                    if(INBB(J,K).eq.-I.and.L14NB(ITYP))then
C   1-4 bound                                     
	              MBSH=MBSH+1
	              if(MBSH.gt.NBSMAX)IESH=1
                      if(IESH.eq.0)then
	                NBS1(MBSH)=-I
		        NBS2(MBSH)=J
                      end if
*            write(*,'(a,2i5,f12.5,2i8)')'1-4s',I,J,sqrt(RR2),MBSH,MBLN
                      go to 125
		    end if  
	  	  end do
	        end if
	      end if ! (RR2.le.RMAX2
	    end if   ! (IMOL.eq.JMOL
*   15.2.1.4 Pick up non-bound atoms to the list of neigbours
	    if(RRM.le.SHORT2)then
	      MBSH=MBSH+1
	      if(MBSH.gt.NBSMAX)IESH=1
              if(IESH.eq.0)then
	        NBS1(MBSH)=I
	        NBS2(MBSH)=J
              end if
*            write(*,'(a,2i5,f12.5,2i8)')'no_s',I,J,sqrt(RR2),MBSH,MBLN
	    else if(RRM.le.RSSQ)then
	      MBLN=MBLN+1
	      if(MBLN.gt.NBLMAX)then
                if(IOVER.eq.0)write(*,*)
     +     '!! list of far neigbours overfilled'
                IOVER=1
              end if
              if(IOVER.eq.0)then
	        NBL1(MBLN)=I
	        NBL2(MBLN)=J
*            write(*,'(a,2i5,f12.5,2i8)')'no_l',I,J,sqrt(RR2),MBSH,MBLN
              end if
	    end if
*   15.2.1.5 RDF calculation
C  omitted            
C   Only at this point we go through all the atom pairs
C   RDF calculation
 125        continue
      IF(LGRC.and.RR2.le.RDFCUT2.and.ME.eq.1.and.NHIST.ge.IHIST)then
	      ISB	= NSITE(J)
	      JSB	= NSITE(I)
*              write(*,*)ISB,JSB,RR2
	      if(NGRI(ISB).le.NGRI(JSB))then
		do JS=1,NGRI(ISB) 
		  if(IGRI(ISB,JS).eq.JSB)then 
		    IP = MGRI(ISB,JS)
	            go to 137  
		  end if
		end do
	      else
		do JS=1,NGRI(JSB)
		  if(IGRI(JSB,JS).eq.ISB)then
		    IP = MGRI(JSB,JS)
	            go to 137
		  end if  
		end do         
	      end if  
	      go to 138
 137	      R1	= sqrt(RR2)
              MM        = R1*DRDFI+1
            if(MM.le.MAX)IRDF(MM,IP) = IRDF(MM,IP)+1
*            write(*,'(2i4,f10.4,4i5)')I,J,R1,MM,IP,NRDF,IRDF(MM,IP)
	    end if ! of LGRC
 138        continue
        end do
        end do
        if(ME.eq.1.and.NHIST.ge.IHIST)NRDF=NRDF+1
        if(IOVER.ne.0)then
          write(*,*)' Insrease NBLMAX in prcm.h for this job to ',MBLN
          I=MBLN/NTOT+1
          write(*,*)' (change  to:  NBLMAX =',I,'* NTOT)'
          stop
        end if
        timev	= timev+cputime(timev0)
	if(IPRINT.lt.7)return
	write(*,*)' Task ',TASKID,
     +'total num.of interactions: ',MBSH,' and ',MBLN
        if(IESH.ne.0)then
          write(*,*)'!!! list of closest neigbours overfilled ',MBSH
          stop
        end if
	return
	end
